#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>

#include <malloc.h>


#include "os.h"
#include "err.h"






os_error * sfree(void ** mem)
{
 if(*mem) free(*mem);
 *mem=NULL;
 return(NULL);
}


// doesn't zero memory

os_error * ralloc(void ** mem,int nbytes)
{
 if(nbytes==0) nbytes++;
 *mem=malloc(nbytes);
 if(*mem==NULL) return(geterror(EMEM));
 return(NULL);
}


os_error * salloc(void ** mem,int nbytes)
{
 if(nbytes==0) nbytes++;
 *mem=calloc(nbytes,1);
 if(*mem==NULL) return(geterror(EMEM));
 return(NULL);
}

os_error * srealloc(void ** handle,int nbytes)
{
 void * mem;

 if(nbytes==0) nbytes++;
 mem=*handle;
 *handle=realloc(*handle,nbytes);
 if(*handle==NULL)
 {
  *handle=mem;
  return(geterror(EMEM));
 }
 return(NULL);
}


os_error * schunk(void ** handle,int size,int chunksize)
{
 void            * mem;
 int               length;

 mem=*handle;
 if(!mem)
 {
  return(salloc(handle,chunksize));
 }
 else
 {
  length=_msize(mem);

  if((size>=length) || (length>(size+chunksize)))
  {
   return(srealloc(handle,(size/chunksize+1)*chunksize));
  }
 }
 return(NULL);
}

